import java.io.*;
import java.util.*;

public class Kontrolno1{
  public static void main(String[] args){
    PhotoAlbum[] list = new PhotoAlbum[3];
    list[0] = new PhotoAlbum();
    try{ list[1] = new BigPhotoAlbum(); } catch(Exception e){}
    list[2] = new PhotoAlbum();
   
    FileInputStream[] duplicates1=null, 
      duplicates2=null, duplicates3=null; 
    try{
      duplicates1 = list[0].getDuplicates();
      duplicates2 = list[1].getDuplicates();
      duplicates3 = list[2].getDuplicates();
    }
    catch(IOException e){
      System.out.println(e.getMessage());
    }
    
    LinkedList<FileInputStream> dups = new LinkedList<FileInputStream>();
    for(int i=0; i<duplicates1.length; i++){
      for(int j=0; j<duplicates2.length; j++){
        for(int k=0; k<duplicates3.length; k++){
          try{
            if(PhotoAlbum.equalPhotos(duplicates1[i], duplicates2[j])
                 &&
               PhotoAlbum.equalPhotos(duplicates2[j], duplicates3[k])){
              dups.add(duplicates1[i]);
              if(!dups.contains(duplicates2[j])) dups.add(duplicates2[j]);
              if(!dups.contains(duplicates3[k])) dups.add(duplicates3[k]);
            }
          }
          catch(IOException e){
            System.out.println(e.getMessage());
          }
        }
      }
    }
    FileInputStream[] DuplicatesInAll = 
      dups.toArray(new FileInputStream[dups.size()]);
    
    
  }
}

class PhotoAlbum{
  private int pagesCount;
  FileInputStream[] photos;
  
  public PhotoAlbum(){
    this.pagesCount = 16;
    this.photos = new FileInputStream[this.pagesCount*3];
  }
  
  public PhotoAlbum(int pagesCount, FileInputStream[] photos) throws Exception{
    if(photos.length > pagesCount*3) throw new Exception("Too many photos");
    this.setPagesCount(pagesCount);
    this.photos = new FileInputStream[this.pagesCount*3];
    for(int i=0; i<photos.length; i++){
      this.photos[i] = photos[i];
    }
  }
  
  public int getPagesCount(){
    return this.pagesCount;
  }
  
  public void setPagesCount(int pagesCount) throws Exception{
    if(pagesCount<10) throw new Exception("Not enough pages for album");
    else this.pagesCount = pagesCount;
  }
  
  static boolean equalPhotos(FileInputStream photo1, FileInputStream photo2) throws IOException{
    if(photo1.equals(photo2)) return true;
    BufferedInputStream input1 = new BufferedInputStream(photo1);
    BufferedInputStream input2 = new BufferedInputStream(photo2);
    int ch1=-1, ch2=-1;
    while ((ch1 = input1.read())!=-1 || (ch2 = input2.read()) != -1){
      if (ch1 != ch2) return false;
    }
    return true;
  }
  
  FileInputStream[] getDuplicates() throws IOException{
    LinkedList<FileInputStream> duplicates = new LinkedList<FileInputStream>();
    for (int i=0; i<this.photos.length-1; i++){
      for (int j=i+1; j<photos.length; j++){
        if (this.equalPhotos(this.photos[i], this.photos[j])){
          duplicates.add(this.photos[i]);
          if(!duplicates.contains(this.photos[j])) duplicates.add(this.photos[j]);
        }
      }
    }
    return duplicates.toArray(new FileInputStream[duplicates.size()]);
  }
  
  void addNewPhoto(FileInputStream newphoto) throws IOException, Exception{
    FileInputStream[] duplicates = this.getDuplicates();
    if(duplicates.length>0){
      int position = 0;
      for(int i=0; i<this.photos.length; i++){
        if(photos[i].equals(duplicates[0])){
          position =i;
          break;
        }
      }
      this.photos[position] = newphoto;
    }
    else{
      for(int i=0; i<this.photos.length; i++){
        if(this.photos[i] == null){
          this.photos[i] = newphoto;
          return;
        }
      }
      throw new Exception("Album is full");
    }
  }
}

class BigPhotoAlbum extends PhotoAlbum{
  
  public BigPhotoAlbum() throws Exception{
      super(64, new FileInputStream[0]);
  }
  
  public BigPhotoAlbum(int pagesCount, FileInputStream[] photos) throws Exception{
    super(pagesCount, photos);
    if(pagesCount<64) throw new Exception("Not enough pages for a big album");
  }
  
  public void setPagesCount(int pagesCount) throws Exception{
    if(pagesCount<64) throw new Exception("Not enough pages for a big album");
    else super.setPagesCount(pagesCount);
  }  
  
}